#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: L2CSTracking.cgi,v 1.3 2003/11/18 22:51:13 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/L2CSTracking.cgi,v $

########################################################################
# L2CSTracking.cgi
#
# Provides a method to control the L2 CS Tracking function of Stinger.
# Stinger GPS under Maxwell 5 support can additional track the new L2
# Civil Signal (L2CS).  This is a future signal planned for SVs in 2004.
# This is under control of a stinger configuration value "lscs_mode". 
# This can be set by using the command
#   put l2cs_mode [off|on]
# Likewise "get l2cs_mode" on the info channel will provide that
# value back to you.
#
# This script is called to put up the HTML form for controlling the
# L2 CS tracking function.  No CGI parameters are used.  When the user
# clicks on OK, the script gpsadmin/setL2CSTracking.cgi is called with
# the desired setting to activate the change.  Only the
# setL2CSTracking.cgi script has access restrictions.  This script
# (L2CSTracking.cgi) is not restricted and anyone can view the form it
# creates.
#
########################################################################


use strict ;
use CGI qw/:standard/;
use Fireball ;

titleWithHelp( 'L2C Tracking Control',
                         '/L2CSTrackingInfo.html'
                       ) ;

# Obtain current setting from gpsinfo system, using sysinfo.
# Response will be of the forms:
#  put l2cs_mode on 
#  put l2cs_mode off
$_ = qx( /usr/local/fireball/sysinfo -p l2cs_mode ) ;
chomp ;

#print $_, br() ;

my (undef, undef, $CSstate) = split( " ", $_ ) ;

print startform( -name=>'theForm', 
                 -action=>'/perl-scripts/gpsadmin/setL2CSTracking.cgi'
               ) ;


my @Control = radio_group( -name=>'L2CSTracking', 
                           -value=>[ 'on', 'off' ],
                           -nolabels=>1,
                           -default=> $CSstate
                         ) ;

print table( {border=>'1'},
             Tr(
                td( {width=>'30', align=>'center'}, $Control[0] ),
                td( b('Enabled'),br(),
                    'L2C Tracking will be used.'
                  )
               ),
             Tr(
                td( {align=>'center'}, $Control[1] ),
                td( b('Disabled'),
                    br(),
                    'L2C Tracking will not be used.'
                  )
               )
           ) ;

print br(),hr() ;


# No action was done. In other words this invocation is just 
# displaying the form for accepting new data.  Put up the buttons.
print button( -name=>'OK', 
              -value=>'OK',
              -onClick=>'parent.submitForm( document.theForm, "" )'
            ) ;
print '&nbsp;' ;
print button( -name=>'Cancel', 
              -value=>'Cancel',
              -onClick=>
            'parent.loadDataFrame( "/perl-scripts/rconfigDisplay.cgi" )'
            ) ;

print endform() ;

 
print end_html() ;

########################################################################
# end of file L2CSTracking.cgi
########################################################################
