#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: doReset.cgi,v 1.9.2.1 2004/08/23 17:59:28 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/doReset.cgi,v $

########################################################################
# doReset.cgi
#
# Script that allows user to restart the system in several ways.
# The script is typically invoked from the /perl-scripts/reset.cgi
# script, when the user selects a type of reset.  Note that although
# that script is not http-secured, this script is.  Requires gpsadmin
# access privileges to run, if security is enabled.
#
# This script is called in one of two ways, depending on the
# cgi parameters:
#       doReset.cgi?clear=1 
#       doReset.cgi?restart=1 
#
# Clear will restart the system after setting a flag file that triggers
# a complete erasure of the almanac data.
#
# Restart will just do a restart of the system.
#
# Both methods restart the system by sending a SIGUSR2 signal to the
# frontpanel_task.  Sudo must be used for the kill since frontpanel
# runs as Root, and this script is the GUI user, netrx.
#
# A warning header is posted that indicates that the user should
# wait a while before attempting further GUI interaction.
#
########################################################################

use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Do Reset' ) ;


#for my $p (param())
#{
#  print "$p = ",param($p),br() ;
#}

my $signal  = 'SIGUSR2' ;   # Default to do a system reset.


if (param('clear'))
{
  print h1( 'CLEARING EPHEMERIS<br />' ) ;

  param('restart', 'yes' ) ; # Enable restart section below.

  $signal = 'SIGHUP' ;
}


if (param('restart'))
{
  print <<EOF ;

<h1>RESTARTING SYSTEM</h1>
Wait approximately three minutes before attempting further access.
     
<Script>
setTimeout( 'parent.document.location = "/perl-scripts/NetRS.cgi"',
            180000
          ) ;
</Script>
EOF

  # Send the desired signal to the frontpanel task
  my $spid = qx( cat /var/run/frontpanel_task.pid ) ;

  system( "/usr/bin/sudo /bin/kill -$signal $spid" ) ;

  # If this is a system reset, set a failsafe that bypasses the
  # frontpanel_task/Signal mechanism.  If we aren't shutdown within
  # 30 seconds, we'll give a direct 'init 6'
  if (param('restart'))
  {
    system( "(sleep 30 ; /usr/bin/sudo /sbin/init 6)&" ) ;
  }
}

print end_html() ;

########################################################################
# end of script doReset.cgi
########################################################################
