#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setL2CSTracking.cgi,v 1.4 2004/05/27 00:00:32 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setL2CSTracking.cgi,v $

########################################################################
# setL2CSTracking.cgi
#
# Sets the control for the L2CS Tracking function.
# The control state in the configuration file is adjusted to match 
# the supplied parameter.  Stinger is informed of the change.
#
# The parameters are:
#   L2CSTracking mode : 'on' or 'off'
#
# Stinger is controlled by using the command
#
#       put l2cs_mode [off|on]
#
# The 'put l2cs_mode [on|off]' string is saved in 
# /etc/sysconfig/stinger.cfg to provide non-volatile storage.
# 
########################################################################


use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set L2CSTracking' ) ;


#print '<PRE>' ;
#foreach my $p (param())
#{
#  print "$p = ", param($p), "\n" ;
#}
#print '</PRE>' ;


my $CSstate = param( 'L2CSTracking' ) ;
if ($CSstate =~ m/^on|off$/ )
{
  newStingerConfig( "put l2cs_mode $CSstate\n" ) ;

  print h2( "L2C Tracking has been ",
            $CSstate eq 'on'
            ? 'enabled.'
            : 'disabled.'
          ) ;

  # After a timeout, go back to main satellite screen.
  print <<EOF;
    <Script>
    parent.loadAfterDelay( "/perl-scripts/rconfigDisplay.cgi", 2000) ;
    </Script>
EOF
}

print end_html() ;

########################################################################
# end of file setL2CSTracking.cgi
########################################################################
